import { NodeApi } from '../../json-crdt/model/api/nodes';
import type { ExtensionDefinition, ObjNode } from '../../json-crdt';
import type { ITimestampStruct } from '../../json-crdt-patch/clock';
import type { ExtensionJsonNode, JsonNode } from '../../json-crdt';
import type { Printable } from 'tree-dump/lib/types';
import type { ExtensionApi } from '../../json-crdt';
declare class CntNode implements ExtensionJsonNode, Printable {
    readonly data: ObjNode;
    readonly id: ITimestampStruct;
    constructor(data: ObjNode);
    name(): string;
    view(): number;
    children(callback: (node: JsonNode) => void): void;
    child?(): JsonNode | undefined;
    container(): JsonNode | undefined;
    api: undefined | unknown;
    toString(tab?: string): string;
}
declare class CntApi extends NodeApi<CntNode> implements ExtensionApi<CntNode> {
    inc(increment: number): this;
}
export declare const CntExt: ExtensionDefinition<ObjNode, CntNode, CntApi>;
export {};
