"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CntExt = void 0;
const DelayedValueBuilder_1 = require("../../json-crdt-patch/builder/DelayedValueBuilder");
const extensions_1 = require("../../json-crdt/extensions");
const printTree_1 = require("tree-dump/lib/printTree");
const nodes_1 = require("../../json-crdt/model/api/nodes");
const name = 'cnt';
class CntNode {
    constructor(data) {
        this.data = data;
        this.api = undefined;
        this.id = data.id;
    }
    // -------------------------------------------------------- ExtensionJsonNode
    name() {
        return name;
    }
    view() {
        const obj = this.data.view();
        let sum = 0;
        for (const key in obj)
            sum += Number(obj[key]);
        return sum;
    }
    children(callback) { }
    child() {
        return this.data;
    }
    container() {
        return this.data.container();
    }
    // ---------------------------------------------------------------- Printable
    toString(tab) {
        return `${this.name()} (${this.view()})` + (0, printTree_1.printTree)(tab, [(tab) => this.data.toString(tab)]);
    }
}
class CntApi extends nodes_1.NodeApi {
    inc(increment) {
        const { api, node } = this;
        const sid = api.model.clock.sid;
        const sidStr = sid.toString(36);
        const value = Number(node.data.get(sidStr)?.view() ?? 0);
        const newValue = value + increment;
        const obj = api.wrap(node.data);
        obj.set({
            [sidStr]: newValue,
        });
        return this;
    }
}
exports.CntExt = {
    id: 1 /* ExtensionId.cnt */,
    name,
    new: (value, sid = 0) => (0, extensions_1.ext)(1 /* ExtensionId.cnt */, (0, DelayedValueBuilder_1.delayed)((builder) => builder.constOrJson(value ? { [sid]: value } : {}))),
    Node: CntNode,
    Api: CntApi,
};
